import {
  select,
  hierarchy,
  partition,
  arc
} from 'd3';

const svg = select('svg');
const g = svg.append('g');
const width = +svg.attr('width');
const height = +svg.attr('height');

const render = () => {
  var data = {
    "name": "A1",
    "children": [
      {
        "name": "B1",
        "children": [
          {
            "name": "C1",
            "value": 100
          },
          {
            "name": "C2",
            "value": 300
          },
          {
            "name": "C3",
            "value": 200
          }
        ]
      },
      {
        "name": "B2",
        "value": 200
      }
    ]
  };
  
  var root = hierarchy(data)
  root.sum((d) => d.value);
  
  var radius = 150;
  var partitionLayout = partition()
    .size([2*Math.PI,radius])
  
  var arcGenerator = arc()
    .startAngle((d) => d.x0)
    .endAngle((d) => d.x1)
    .innerRadius((d) => d.y0)
    .outerRadius((d) => d.y1);
  
  partitionLayout(root)
  
  svg.append('g')
      .attr('transform', 'translate(160,160)')
    .selectAll('path')
    .data(root.descendants())
    .enter()
    .append('path')
    .attr('d', arcGenerator);
  
  
//   var root = hierarchy(data);
//   root.sum((d) => d.value);
  
//   var partitionLayout = partition();
//   partitionLayout.size([400,200]);
//   partitionLayout.padding(2);
  
//   partitionLayout(root);
  
//   svg.selectAll('rect')
//     .data(root.descendants())
//     .enter()
//     .append('rect')
//       .attr('x', (d) => d.x0)
//       .attr('y', (d) => d.y0)
//       .attr('width', (d) => d.x1 - d.x0)
//       .attr('height', (d) => d.y1 - d.y0);
  
  
};

render();


















